<template>
  <div class="container mt-5">
    <h2>Cadastrar novo chamado</h2>
    <div class="panel-group">
      <div class="panel panel-default">
        <div class="card-header">
          <div class="row">
            <button class="btn btn-info mx-1" @click="showClient()">
              Cliente
            </button>
            <button class="btn btn-info mx-1" @click="showProduct()">
              Produto
            </button>
            <button class="btn btn-info mx-1" @click="showOrder()">
              Chamado
            </button>
          </div>
          <div class="row">
            <!-- cliente  -->

            <transition name="component-fade" mode="out-in">
              <div class="card-body" v-show="card_client">
                <h4>Buscar/Cadastrar Cliente</h4>
                <form @submit.prevent="salvar">
                  <div class="form-group row">
                    <div class="col-md-12">
                      <label>Nome</label>
                      <input
                        type="text"
                        class="form-control"
                        name="nome"
                        ref="nome"
                        v-model="cliente.nome"
                        placeholder="nome"
                        required
                        :disabled="inputClient === 0"
                      />
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-12">
                      <label>Endereço</label>
                      <input
                        type="text"
                        class="form-control"
                        name="endereco"
                        v-model="cliente.endereco"
                        placeholder="Endereço"
                        required
                        :disabled="inputClient === 0"
                      />
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-6">
                      <label>Email</label>
                      <input
                        type="text"
                        class="form-control"
                        name="email"
                        v-model="cliente.email"
                        placeholder="email"
                        required
                        :disabled="inputClient === 0"
                      />
                    </div>

                    <div class="col-md-6">
                      <label>Telefone</label>
                      <input
                        type="text"
                        class="form-control"
                        name="telefone"
                        v-model="cliente.telefone"
                        placeholder="telefone"
                        required
                        :disabled="inputClient === 0"
                      />
                    </div>
                  </div>
                  <div class="form-group row">
                    

                    <div class="col-md-6">
                      <label>Valor devido</label>
                      <input
                        type="text"
                        class="form-control"
                        name="valor"
                        v-model="cliente.valor"
                        placeholder="Valor devido"
                        required
                        :disabled="inputClient === 0"
                      />
                    </div>
                  
                    <div class="col-md-6">
                      <label>CPF</label>
                      <input
                        type="text"
                        class="form-control"
                        name="cpf"
                        v-model="cliente.cpf"
                        placeholder="cpf"
                        required
                        :disabled="inputClient === 1"
                      />
                    </div>
                  </div>
                  <div class="form-group row">
                    <a
                      class="btn btn-warning mx-3 float-right"
                      @click="searchClient(cliente.cpf)"
                      v-show="buttonSearchClient"
                    >
                      <i class="fas fa-search "></i>{{ buttonClient }}
                    </a>
                    <a
                      type="submit"
                      class="btn btn-success text-white float-right text-white"
                      value="Salvar"
                      @click="saveClient()"
                      v-show="buttonSaveClient"
                    >
                      <i class="fas fa-plus-circle"></i>salvar
                    </a>
                  </div>
                </form>
              </div>
            </transition>

            <!-- product -->
            <transition name="component-fade" mode="out-in">
              <div class="card-body" v-show="card_product">
                <h4>Buscar/Cadastrar Produto</h4>
                <div class="card-body">
                  <form @submit.prevent="salvar">
                    <div class="form-group row">
                      <div class="col-md-12">
                        <label>ID do equipamento quandop gerado</label>
                        <input
                          type="text"
                          class="form-control"
                          name="id"
                          ref="id"
                          v-model="produto.id"
                          placeholder="id equipamento"
                          :disabled="inputProduct === 1"
                          required
                        />
                      </div>
                    </div>
                    <div class="form-group row">
                      <div class="col-md-12">
                        <label>Número de série de fabrica</label>
                        <input
                          type="text"
                          class="form-control"
                          name="id"
                          ref="id"
                          v-model="produto.nserie"
                          placeholder="Número de série"
                          :disabled="inputProduct === 0"
                          required
                        />
                      </div>
                    </div>
                    <div class="form-group row">
                      <div class="col-md-6">
                        <label>Marca</label>
                        <input
                          type="text"
                          class="form-control"
                          name="marca"
                          v-model="produto.marca"
                          placeholder="marca"
                          required
                          :disabled="inputProduct === 0"
                        />
                      </div>

                      <div class="col-md-6">
                        <div class="row">
                        <label>Garantia:  {{ emgarantia }}</label>
                       
                        </div>
                        <input
                          type="text"
                          class="form-control"
                          name="dataGarantia"
                          v-model="produto.dataGarantia"
                          placeholder="data de Garantia"
                          required
                          :disabled='true'
                        />
                      </div>
                    </div>
                    <div class="form-group row">
                      <div class="col-md-12">
                        <label>Modelo</label>
                        <input
                          type="text"
                          class="form-control"
                          name="modelo"
                          v-model="produto.modelo"
                          placeholder="modelo"
                          required
                          :disabled="inputProduct === 0"
                        />
                      </div>
                    </div>
                    <div class="form-group row">
                      <div class="col-md-12">
                        <label>Descrição de como se encontra o produto</label>
                        <input
                          type="text"
                          class="form-control"
                          name="descProduto"
                          v-model="produto.descProduto"
                          placeholder="Descrição do Produto"
                          required
                          :disabled="inputProduct === 0"
                        />
                      </div>
                    </div>
                    <!-- <a class="btn btn-primary text-white float-right"  v-show="!tipo"  >
                      <i class="fas fa-sync"></i>Atualizar
                    </a> -->
                    <div class="form-group row">
                      <a
                        class="btn btn-warning mx-3 float-right"
                        @click="searchProduct(produto.id)"
                        v-show="buttonSearchProduto"
                      >
                        <i class="fas fa-search"></i>{{ buttonProduct }}
                      </a>
                      <a
                        type="submit"
                        class="
                          btn btn-success
                          text-white
                          float-right
                          text-white
                        "
                        v-show="buttonSaveProduct"
                        value="Salvar"
                        @click="saveProduct()"
                      >
                        <i class="fas fa-plus-circle"></i>salvar
                      </a>
                    </div>
                  </form>
                </div>
              </div>
            </transition>

            <!-- order -->
            <transition name="component-fade" mode="out-in">
              <div class="card-body" v-show="card_order">
                <h4>Criar Chamado</h4>
                <form @submit.prevent="salvar">
                  <div class="form-group row">
                    <div class="col-md-12">
                      <label>Defeito Relatado pelo cliente</label>
                      <input
                        type="text"
                        class="form-control"
                        name="defApresentado"
                        ref="defRelatado"
                        v-model="chamado.defRelatado"
                        placeholder="Defeito Relatado"
                        required
                      />
                    </div>
                  </div>
                  <div class="form-group row">
                    <div class="col-md-4">
                      <label>meses de garantia após entrega</label>
                      <input
                        type="text"
                        class="form-control"
                        name="cliente_id"
                        v-model="chamado.periodWaranty"
                        placeholder="meses"
                        required
                      />
                    </div>
                    <div class="col-md-4">
                      <label>ID do Cliente no Sistema</label>
                      <input
                        type="text"
                        class="form-control"
                        name="cliente_id"
                        v-model="chamado.cliente_id"
                        placeholder="Cliente_id"
                        required
                      />
                    </div>
                    <div class="col-md-4">
                      <label>Id do produto no sistema</label>
                      <input
                        type="text"
                        class="form-control"
                        name="produto_id"
                        v-model="chamado.produto_id"
                        placeholder="produto_id"
                        required
                      />
                    </div>
                  </div>
                  <div class="form-group row">

                    <div class="col-md-12">
                      <label
                        >Data de previsão de envio do orçamento para o
                        cliente</label
                      >
                  <date-picker v-model="chamado.dataPrev" lang="pt-br" type="date" format="DD/MM/YYYY"></date-picker>
                      
                      <!-- <input
                        type="text"
                        class="form-control"
                        name="dataPrev"
                        v-model="chamado.dataPrev"
                        placeholder="data de previsão"
                        required
                      /> -->
                    </div>
                  </div>

                  <div class="form-group row">
                    <!-- <a class="btn btn-primary text-white float-right"  v-show="!tipo"  >
                      <i class="fas fa-sync"></i>Atualizar
                    </a> -->
                    <a
                      type="submit"
                      class="btn btn-success text-white float-right text-white"
                      value="Salvar"
                      @click="saveOrder()"
                    >
                      <i class="fas fa-tools"></i> Salvar
                    </a>
                  </div>
                </form>
              </div>
            </transition>
          </div>

          <!-- table client -->
          <transition name="component-fade" mode="out-in">
            <table class="table table-striped mt-5" v-show="card_client">
              <thead>
                <tr>
                  <th>ID</th>
                  <th>nome</th>
                  <th>email</th>
                  <th>valor devido</th>
                </tr>
              </thead>

              <tbody>
                <tr v-for="cliente in clientes" v-bind:key="cliente.id">
                  <td>{{ cliente.id }}</td>
                  <td>{{ cliente.nome }}</td>
                  <td>{{ cliente.email }}</td>
                  <td>{{ cliente.valor }}</td>
                  <td>
                    <a
                      data-toggle="collapse"
                      href="'#' + cliente.id"
                      class="btn btn-sm btn-primary mx-1"
                      @click="editClient(cliente.id)"
                    >
                      <i class="fas fa-plus" title="Alterar"></i>
                    </a>
                  </td>
                </tr>
              </tbody>
            </table>
          </transition>

          <!-- table product -->
          <transition name="component-fade" mode="out-in">
            <table class="table table-striped mt-5" v-show="card_product">
              <thead>
                <tr>
                  <th>ID</th>
                  <th>N. Série</th>
                  <th>marca</th>
                  <th>modelo</th>
                  <th>garantia</th>
                </tr>
              </thead>

              <tbody>
                <tr v-for="produto in produtos" v-bind:key="produto.id">
                  <td>{{ produto.id }}</td>
                  <td>{{ produto.nserie }}</td>
                  <td>{{ produto.marca }}</td>
                  <td>{{ produto.modelo }}</td>
                  <td>{{ produto.dataGarantia }}</td>
                  <td>
                    <a
                      data-toggle="collapse"
                      href="'#' + produto.id"
                      class="btn btn-sm btn-primary mx-1"
                      @click="editProduct(produto.id)"
                    >
                      <i class="fas fa-plus" title="Alterar"></i>
                    </a>
                  </td>
                </tr>
              </tbody>
            </table>
          </transition>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
import axios from "axios";
import DatePicker from 'vue2-datepicker'
import 'vue2-datepicker/index.css';
// https://www.youtube.com/watch?v=pV1ZwHY0zNM
export default {
  components:{
    DatePicker
  },
  data() {
    return {
      date_picker:'',

      emgarantia: null,

      buttonSearchClient: true,
      buttonSearchProduto: true,
      inputClient: 0,
      inputClientKey: 0,
      inputProduct: 0,

      flagProduct: true,
      flagClient: true,

      buttonSaveClient: false,
      buttonSaveProduct: false,

      buttonClient: "Buscar",
      buttonProduct: "Buscar",

      stringBusca: "",
      chamados: null,

      chamado: {
        id: null,
        defRelatado: null,
        valor: null,
        status: 1,
        dataPrev: null,
        cliente_id: null,
        produto_id: null,
        componentsJson: [],
        periodWaranty: null,
      },
      clientes: null,
      cliente: {
        id: null,
        user_id: null,
        nome: null,
        email: null,
        cpf: null,
        telefone: null,
        endereco: null,
        senha: null,
        valor: null,
      },
      produtos: null,
      produto: {
        id: null,
        nserie: null,
        marca: null,
        modelo: null,
        descProduto: null,
        dataGarantia: null,
      },
      card_client: true,
      card_product: false,
      card_order: false,
    };
  },
  methods: {
    showClient() {
      this.card_client = true;
      this.card_product = false;
      this.card_order = false;
    },
    showProduct() {
      this.card_client = false;
      this.card_product = true;
      this.card_order = false;
    },
    showOrder() {
      this.card_client = false;
      this.card_product = false;
      this.card_order = true;
    },
    // clientes
    // -----------------------------------//
    saveClient() {
      this.cliente.senha = this.cliente.cpf
      if (this.cliente.id) {
        axios
          .put(
            this.$MainURL + "/clientes/" + this.cliente.user_id,
            this.cliente,
            {
              headers: {
                Authorization: `Bearer ${localStorage.getItem("token")}`,
              },
            }
          )
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.cliente = {};
            this.clientes = null;
            this.cliente.id = "";
            this.cliente.nome = "";
            this.cliente.email = "";
            this.cliente.cpf = "";
            this.cliente.telefone = "";
            this.cliente.endereco = "";
            this.cliente.senha = "";
            this.cliente.valor = "";
            this.chamado.cliente_id = "";
            this.buttonClient = "Buscar";
            this.inputClient = 0;
            this.inputClientKey = 0;
            this.buttonSaveClient = false;
          });
      } else {
        axios
          .post(this.$MainURL + "/clientes", this.cliente, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.cliente = {};
            this.clientes = null;
            this.cliente.id = "";
            this.cliente.nome = "";
            this.cliente.email = "";
            this.cliente.cpf = "";
            this.cliente.telefone = "";
            this.cliente.endereco = "";
            this.cliente.senha = "";
            this.cliente.valor = "";
            this.chamado.cliente_id = "";
            this.buttonClient = "Buscar";
            this.inputClient = 0;
            this.inputClientKey = 0;
            this.buttonSaveClient = false;
          });
      }
    },

    verifyWaranty() {
      let dataAtual = new Date();

      let dataWaranty = this.produto.dataGarantia

      console.log("atual", Date.parse(dataAtual));
      console.log("garantia", Date.parse(dataWaranty));

      if (Date.parse(dataWaranty) >= Date.parse(dataAtual)) {
        this.emgarantia = " em garantia";
      } 
      else if (!this.produto.dataGarantia) {
        this.emgarantia = "";
      } 
      else {
        this.emgarantia = " fora da garantia";
      }
    },

    editClient(id) {
      axios
        .get(this.$MainURL + "/cliente/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          this.cliente = response.data;
          this.chamado.cliente_id = this.cliente.user_id;
          this.inputClient = 1;
          this.$refs.nome.focus();
          this.buttonClient = "Limpar";
          this.buttonSaveClient = false;
        });
    },
    searchClient(cpf) {
      if (this.inputClient == 1) {
        this.clientes = null;
        this.cliente.id = "";
        this.cliente.nome = "";
        this.cliente.email = "";
        this.cliente.cpf = "";
        this.cliente.telefone = "";
        this.cliente.endereco = "";
        this.cliente.senha = "";
        this.cliente.valor = "";
        this.chamado.cliente_id = "";
        this.buttonClient = "Buscar";
        this.inputClient = 0;
        this.inputClientKey = 0;
        this.buttonSaveClient = false;
      } else {
        if (cpf) {
          axios
            .get(this.$MainURL + "/clientes/" + cpf, {
              headers: {
                Authorization: `Bearer ${localStorage.getItem("token")}`,
              },
            })
            .then((response) => {
              this.clientes = response.data;
              console.log(this.clientes.erro);
              if (this.clientes.erro) {
                alert("não encontrado, faça o cadastro");
                this.buttonSaveClient = true;
                this.inputClient = 1;
                this.inputClientKey = 1;
                this.buttonClient = "Limpar";
              }
            });
        } else {
          alert("informe algum valor");
        }
      }
    },

    // produtos
    // ------------------------------------//
    saveProduct() {
      if (this.produto.id) {
        axios
          .put(this.$MainURL + "/produtos/" + this.produto.id, this.produto, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.produto = {};
            this.produtos = null;
            this.inputProduct = 0;
            this.produto.id = "";
            this.produto.marca = "";
            this.produto.dataGarantia = "";
            this.produto.modelo = "";
            this.produto.descProduto = "";
            this.chamado.produto_id = "";
            this.buttonProduct = "Buscar";
            this.buttonSaveProduct = false;
          });
      } else {
        axios
          .post(this.$MainURL + "/produtos", this.produto, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.produto = {};
            this.produtos = null;
            this.inputProduct = 0;
            this.produto.id = "";
            this.produto.nserie = "";
            this.produto.marca = "";
            this.produto.dataGarantia = "";
            this.produto.modelo = "";
            this.produto.descProduto = "";
            this.chamado.produto_id = "";
            this.buttonProduct = "Buscar";
            this.buttonSaveProduct = false;
          });
      }
    },
    editProduct(id) {
      axios
        .get(this.$MainURL + "/produto/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => {
          this.produto = response.data;
          this.chamado.produto_id = this.produto.id;
          this.inputProduct = 1;
          this.$refs.id.focus();
          this.buttonProduct = "Limpar";
          this.verifyWaranty();
        });
    },
    searchProduct(id) {
      if (this.inputProduct == 1) {
        this.produtos = null;
        this.inputProduct = 0;
        this.produto.id = "";
        this.produto.nserie = "";
        this.produto.marca = "";
        this.produto.dataGarantia = "";
        this.produto.modelo = "";
        this.produto.descProduto = "";
        this.chamado.produto_id = "";
        this.buttonProduct = "Buscar";
        this.buttonSaveProduct = false;
      } else {
        if (id) {
          axios
            .get(this.$MainURL + "/produtos/" + id, {
              headers: {
                Authorization: `Bearer ${localStorage.getItem("token")}`,
              },
            })
            .then((response) => {
              this.produtos = response.data;
              console.log(this.produtos);
              if (this.produtos.erro) {
                alert("não encontrado, faça o cadastro");
                this.produto.id = "";
                this.inputProduct = 1;
                this.buttonSaveProduct = true;
              }
            });
        } else {
          alert("informe algum valor");
        }
      }
    },

    // chamados
    // ------------------------------------//
    listar() {
      axios
        .get(this.$MainURL + "/chamados", {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        .then((response) => (this.chamados = response.data));
    },
    searchOrder(nome) {
      if (!nome) {
        this.listar();
      } else {
        axios
          .get(this.$MainURL + "/chamados/" + nome, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => (this.chamados = response.data));
      }
    },
    saveOrder() {
      if (this.chamado.id) {
        axios
          .put(this.$MainURL + "/chamados/" + this.chamado.id, this.chamado, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          // eslint-disable-next-line no-unused-vars
          .then((response) => {
            alert(`Ok, Alterado com sucesso`);
            this.listar();
            this.chamado = {};
          });
      } else {
        axios
          .post(this.$MainURL + "/chamados", this.chamado, {
            headers: {
              Authorization: `Bearer ${localStorage.getItem("token")}`,
            },
          })
          .then((response) => {
            alert(`Ok, cadastrado com ID: ${response.data.id}`);
            this.listar();
            this.chamado = {};
            this.clientes = null;
            this.cliente.id = "";
            this.cliente.nome = "";
            this.cliente.email = "";
            this.cliente.cpf = "";
            this.cliente.telefone = "";
            this.cliente.endereco = "";
            this.cliente.senha = "";
            this.cliente.valor = "";
            this.chamado.cliente_id = "";
            this.buttonClient = "Buscar";
            this.inputClient = 0;
            this.inputClientKey = 0;
            this.buttonSaveClient = false;
            this.produtos = null;
            this.inputProduct = 0;
            this.produto.id = "";
            this.produto.nserie = "";
            this.produto.marca = "";
            this.produto.dataGarantia = "";
            this.produto.modelo = "";
            this.produto.descProduto = "";
            this.chamado.produto_id = "";
            this.buttonProduct = "Buscar";
            this.buttonSaveProduct = false;
          });
      }
    },
    editOrder(id) {
      axios
        .get(this.$MainURL + "/chamados/" + id, {
          headers: { Authorization: `Bearer ${localStorage.getItem("token")}` },
        })
        .then((response) => (this.chamado = response.data));
      this.$refs.nome.focus();
    },
    excluir(id, cod) {
      if (confirm(`Confirma exclusão do filme '${cod}`));
      axios
        .delete(this.$MainURL + "/chamados/" + id, {
          headers: {
            Authorization: `Bearer ${localStorage.getItem("token")}`,
          },
        })
        // eslint-disable-next-line no-unused-vars
        .then((response) => {
          alert(`chamado '${cod}' excluido com sucesso`);
          this.listar();
        });
    },
  },

  mounted() {
    this.listar();
  },
};
</script>

<style scoped>
.component-fade-enter-active {
  transition: all 0.5s;
}

.component-fade-leave-active {
  transition: all 0s;
}
.component-fade-enter,
.component-fade-leave-active {
  opacity: 0;
}
.component-fade-enter {
  transform: translateX(31px);
}
.component-fade-leave-active {
  transform: translateX(-31px);
}
</style>
